#if UNITY_5_3_OR_NEWER
using System.IO;
using System.Text;
using UnityEngine;

namespace RoboidControl.Unity {

    public class UnityLogWriter : TextWriter {
        public override void Write(char value) {
            Debug.Log(value);
        }

        public override void Write(string value) {
            Debug.Log(value);
        }

        public override void WriteLine(string value) {
            Debug.Log(value);
        }

        public override Encoding Encoding => Encoding.UTF8;
    }
    
}
#endif